// implementation of the 4x3 MDP

#include "4x3.h"
#include "minmax.h"
#include <fstream.h>

/*
void FourBy3Problem::UpdateInverseModel(FourBy3State & startState,
				      FourBy3Action & act,
				      FourBy3State & endState)
{
  list<PredecessorInfo<FourBy3State, FourBy3Action> *> & piList =
    pi[stateIndex(endState)];
  // need to see if state and action all ready exist.  They shouldn't
  // but we will check just in case.
  listIterator<PredecessorInfo<FourBy3State, FourBy3Action> *> itr(piList);
  for (itr.init(); !itr; ++itr) {
    if (itr()->state == startState &&
	itr()->action == act) {
      cerr << "startState and act already exist in model!";
      cerr << " startState = " << stateIndex(startState)
	   << " act = " << act << endl;
      break;
    }
  }
  piList.add(new PredecessorInfo<FourBy3State, FourBy3Action>(startState, act));
}
*/

// the numbers in the input file begin with 1.
istream & operator >> (istream & str, FourBy3State & s) 
{
  char delim;
  str >> delim;
  if (delim != '(') {
    cerr << "Found `" << delim << "' where `(' was expected." << endl;
  }
  str >> s.n1;  s.n1--;
  str >> s.n2;  s.n2--;
  str >> delim;
  if (delim != ')') {
    cerr << "Found `" << delim << "' where `)' was expected." << endl;
  }
  return str;
}

ostream & operator << (ostream & str, FourBy3State & s)
{
  str << "(" << s.n1 + 1 << " " << s.n2 + 1 << ")";
  return str;
}

void FourBy3Problem::buildModel()
{
  // we read the model in from a file.
  ifstream  str("4x3.txt");
  if (!str) {
    cerr << "Unable to open 4x3.txt" << endl;
    abort();
  }
  for (int i = 0; i < 9; i++) {
    char delim;
    str >> delim;
    if (delim != '(') {
      cerr << "While reading model, saw `" << delim << "' but expected `('."
	   << endl;
      abort();
    }
    FourBy3State s;
    str >> s;
    cout << "Reading model for state " << s << endl;
    list<SuccessorInfo<FourBy3State, FourBy3Action> *> & siList =
      si[stateIndex(s)];
    str >> siList;
    
    str >> delim;
    if (delim != ')') {
      cerr << "While reading model, saw `" << delim << "' but expected `)'."
	   << endl;
      abort();
    }
  }
  cout << "Finished reading model" << endl;
}
